--------------------------------------------------
-- Mir AI -> Genetic AI Config
--------------------------------------------------
--[[
--   Webpage: http://ksp.sk/~morgoth/baka/
--]]
--------------------------------------------------
-- HOW TO ACTIVATE THIS MOD:
-- 1. open the Control Panel,
-- 2. choose the "Extra" Tab,
-- 3. and select GeneticAI_Mod.lua
-- (if you don't use the control panel: open SelectMod.lua and replace "Standard_Mod" with "GeneticAI_Mod")

--------------------------------------------------
-- Extra Globals
--------------------------------------------------


-- [### CONFIG START]
WriteTimeout 	= 5000		-- kazdych 5000 milisekund
TestingTime 	= 600		-- 600 sekund testovaci cas
MutationRate	= 50		-- 50/1000
PopulationSize	= 20		-- velkost populacie
Elitism		= 30 		-- 30% elitarov
-- [### CONFIG END]

require "./AI/USER_AI/GA/mobdata.lua"
require "./AI/USER_AI/GA/ga_const.lua"
require "./AI/USER_AI/Const.lua"

-- Variables

--------------------------------------------------
function Logg(text)
--------------------------------------------------
	local CurrTime = GetTick()
	local dt= CurrTime - LastLogTime
	if LastLogTime == 0 then dt = 0 end
	if FirstLogTime==nil then FirstLogTime=CurrTime end
	LastLogTime = CurrTime

	local f_out=io.open('./AI/USER_AI/GA/logg.txt', "a")
	if f_out~=nil then
		f_out:write(CurrTime-FirstLogTime..'ms | '..dt..'ms: '..text .. "\n")
		f_out:close()
	end
end

--------------------------------------------------
function FileAppend(file,what)
--------------------------------------------------
	local f_out = io.open(file, "a")
	if f_out~=nil then
		f_out:write(what.. "\n")
		f_out:close()
	end
end

--------------------------------------------------
function file_exists(path)
--------------------------------------------------
  local file = io.open(path, "r")
  if file then file:close() end
  return file ~= nil
end

--------------------------------------------------
function LoadFile(name)
--------------------------------------------------
	Logg('LoadFile<-'..name)
	local file=loadfile(name)
	if not file then 
		Logg('LoadFile -> no file found')	
		return 
	end
	file = file()
	if not file then 
		Logg('LoadFile -> failed parsing')
		return 
	end
	Logg('LoadFile -> success')
	return file
end

--------------------------------------------------
function SaveSettings()
--------------------------------------------------
	Logg('SaveSettings')
	local f = io.open('./AI/USER_AI/GA/settings.lua',"w")

	Settings.Fitness=CalcFitness()
	f:write('return {\n')
	f:write(Serialize(Settings))
	f:write('}\n')
	f:close()
	WriteTime=GetTick()
end

--------------------------------------------------
function sizeof(sth)
--------------------------------------------------
	local n=0
	if (type(sth)~="table") then return 0 end
	for i,v in pairs(sth) do n=n+1 end
	return n
end

--------------------------------------------------
function Serialize(data)
--------------------------------------------------
	Logg('Serialize')
	local str=''

	if (data.TotalTime~=nil) then str=str..'TotalTime='..data.TotalTime..',\n' end
	if (data.TotalExp~=nil)  then str=str..'TotalExp=' ..data.TotalExp.. ',\n' end
	if (data.TotalKills~=nil)then str=str..'TotalKills=' ..data.TotalKills.. ',\n' end
	if (data.Fitness~=nil)then str=str..'Fitness=' ..data.Fitness.. ',\n' end
	
	str=str..'DNA={\n'
	local temp={}
	for i,v in pairs(data.DNA) do
		if temp[v[1]]==nil then
			str=str..'  {'..v[1]..','..beha_const[v[2]]..','..skill_const[v[3]]
			str=str..','..v[4]..'}, -- '..MOBDATA[v[1]][MOB_P_iName]..'\n'
			temp[v[1]]=1
		end

	end
	str=str..'  }\n'

	return str
end

--------------------------------------------------
function CalcFitness()
--------------------------------------------------
	--toto je customizovatelne, ako najrozumnejsie zatial pocet expov za hodinu
	if (Settings.TotalTime==0) then return 0 end
	return (Settings.TotalExp/(Settings.TotalTime/3600000))
end

--------------------------------------------------
function Tick()
--------------------------------------------------
	Logg('Tick')
	CurrTime=GetTick()

	if (Settings.TimeStart==nil)then --ak nemam udane kedy som zacal, zacal som teraz
		Settings.TimeStart=CurrTime
	else 
		Settings.TotalTime=Settings.TotalTime+CurrTime-Settings.TimeStart --update celkoveho casu
		Settings.TimeStart=CurrTime
	end
	if (CurrTime-WriteTime>WriteTimeout) then --chcem zapisat co jedinec pozabijal?
		SaveSettings()
	end
	if (Settings.TotalTime/1000>TestingTime) then -- koniec jedinca
		Settings.Fitness=CalcFitness()
		local str=Serialize(Settings)

		if (file_exists('./AI/USER_AI/GA/tested.lua')) then
			Logg('Jedinec pripisany do suboru otestovanych sociek;')
			local tested=LoadFile('./AI/USER_AI/GA/tested.lua')
			
			file=io.open('./AI/USER_AI/GA/tested.lua',"w")
			file:write('return {\n')
			if (tested~=nil) then
				for i,v in ipairs(tested) do file:write('{'..Serialize(v)..'},\n') end
			end
			file:write('{'..str..'}\n')
			file:write('}')
			file:close()
		else 
			Logg('Jedinec zapisany do suboru otestovanych sociek;')
			local f = io.open('./AI/USER_AI/GA/tested.lua',"w")
			f:write('return {{'..str..'}\n}') --zapisem jedinca do suboru
			f:close()
		end
		
		FileAppend('./AI/USER_AI/GA/history.lua','{'..str..'},')

		os.remove('./AI/USER_AI/GA/settings.lua') --premazem subor s jedincom, nech ho netestujem 2x
		LoadNextCreature() --nahram dalsieho jedinca z populacie
	end
end

--------------------------------------------------
function InitPopulation()
--------------------------------------------------
	Logg('=== InitPopulation ===')
	return {
		{DNA={}}--prazdna DNA-pobeha, preskuma a pridaju sa mu prisery
	} 
end


--------------------------------------------------
function sort(x,n,f)
--------------------------------------------------
 local i=1
 while i<=n do
  local m,j=i,i+1
  while j<=n do
   if f(x[j],x[m]) then m=j end
   j=j+1
  end
 x[i],x[m]=x[m],x[i]
 i=i+1
 end
end

--------------------------------------------------
function deepcopy(object)
--------------------------------------------------
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

--------------------------------------------------
function Cross(x,y) --DNA 2 jedincov
--------------------------------------------------
	--Logg('Cross X:\n'..print_r(x)..'\nWith Y:\n'..print_r(y))
	if (math.random(2)==1) then t=x x=y y=t end
	local nx=sizeof(x)
	local ny=sizeof(y)
	local known={} 
	local backx={} 
	local backy={}

	for i,v in ipairs(x) do known[v[1]]=1 backx[v[1]]=v end
	for i,v in ipairs(y) do known[v[1]]=1 backy[v[1]]=v end
	
	--Logg('Known are :'..print_r(known))
	nk=sizeof(known)
	local point=math.random(nk) --na tomto mieste rozdelim
	ret={}
	local w=1
	for k,v in pairs(known) do
		if (w<nk) then ret[w]=deepcopy(backx[k]) else ret[w]=deepcopy(backy[k])	end
		w=w+1
	end
	--Logg('Result is: '..print_r(ret))
	return ret
end

--------------------------------------------------
function Mutate(x)
--------------------------------------------------
	--Logg('Mutate')
	for i,v in pairs(x) do 
		for j=2,4 do 
			if math.random(1000)<MutationRate then v[j]=math.random(const_max[j][1],const_max[j][2]) end 
		end
	end
end

--------------------------------------------------
function NewPopulation()
--------------------------------------------------
	Logg('NewPopulation')

	old=LoadFile('./AI/USER_AI/GA/tested.lua')
	local n
	if (old~=nil) then n=sizeof(old) else n=0 end

	if (n==0) then 
		Logg('=== Pouzivam Default populaciu! ===')
		new=InitPopulation() 
	else
		Logg('Stara populacia ma velkost :'..n)
		sort(old,n,function (x,y) return x.Fitness>y.Fitness end)
		local pocet=math.min(sizeof(old),math.floor(PopulationSize*Elitism/100))
		Logg('A do vybralo sa prvych '..pocet..' jedincov do dalsej!')
		new={}

		for i=1,pocet do new[i]={} new[i].DNA=deepcopy(old[i].DNA) end
		for i=pocet+1,PopulationSize do
			--nahodny rodic z populacie sa skrizi s dalsim
			new[i]={}
			new[i].DNA=Cross(new[math.random(pocet)].DNA,new[math.random(pocet)].DNA)
			Mutate(new[i].DNA)
		end
	end

	file=io.open('./AI/USER_AI/GA/population.lua',"w")
	file:write('return {\n')
	for i,v in ipairs(new) do file:write('{'..Serialize(new[i])..'},\n') end
	file:write('}')
	file:close()
	os.remove('./AI/USER_AI/GA/tested.lua')
end
--------------------------------------------------
function LoadNextCreature()
--------------------------------------------------
	Logg('LoadNextCreature')
	Population=LoadFile("./AI/USER_AI/GA/population.lua") --nahram populaciu
	local size
	if (Population~=nil) then size=sizeof(Population) else size=0 end
	os.remove("./AI/USER_AI/GA/population.lua")

	if (size==0) then --ak dosla populacia, vyrobim si novu
		NewPopulation()		
		Population=LoadFile("./AI/USER_AI/GA/population.lua")
	end 

	Logg('Kopirujem zvysok populacie do population.lua')

	first=1
	local f
	for i,v in ipairs(Population) do 
		if (first==1)then 
			Settings=v
			first=2
		else
			if (first==2)then
				f=io.open('./AI/USER_AI/GA/population.lua',"w")
				f:write('return {')
				first=0;
			end
			f:write('{'..Serialize(v)..'},')
		end
	end
	if (first==0) then f:write('}\n') f:close() end

	--v settings je novy jedinec
	CurrTime=GetTick()
	ApplyDNA(Settings.DNA)
	Settings.TotalTime=0
	Settings.TotalExp=0
	Settings.TotalKills=0
	Settings.TimeStart=CurrTime
	Settings.Creatures={}
	for i,v in pairs(Settings.DNA) do Settings.Creatures[v[1]]=1 end --prisery ktore "poznam"

	SaveSettings()
	WriteTime=CurrTime
end

--------------------------------------------------
function print_r (t, indent)
--------------------------------------------------
local print_string=''
	
	function printr (t, indent)
	  local indent=indent or ''
	  for key,value in pairs(t) do
	    print_string=print_string..indent..'['..tostring(key)..']'
	    if type(value)=="table" then print_string=print_string..':\n'
		    printr(value,indent..'\t')
	    else print_string=print_string..' = '..tostring(value)..'\n' end
	  end
	end
	
	printr(t,indent)
	return print_string

end

--------------------------------------------------
function GAOnInit()
-- On Init: loadnut nastavenie, zapisat stary cas
----------------------------------------------------
	Logg('GaOnInit()')
	Settings=LoadFile("./AI/USER_AI/GA/settings.lua")--toto sa nepremazava

	if (Settings==nil) then LoadNextCreature() end
	Settings.Creatures={}

	for i,v in pairs(Settings.DNA) do Settings.Creatures[v[1]]=1 end --prisery ktore "poznam"

	if (Settings.TotalTime==nil) then Settings.TotalTime=0 end
	if (Settings.TotalExp==nil)  then Settings.TotalExp=0 end
	if (Settings.TotalKills==nil)then Settings.TotalKills=0 end
	
	Logg('Settings: '..print_r(Settings))

	ApplyDNA(Settings.DNA)
	Tick()	
end

--------------------------------------------------
function ApplyDNA(DNA)
--------------------------------------------------
	Logg('ApplyDNA')
	for i,v in pairs(DNA) do 
		Logg('Aplikujem DNA na moba '..v[1])
		Tact[v[1]]={Tact[v[1]][1],v[2],v[3],v[4],Tact[v[1]][5]}
	end
end

--------------------------------------------------
function OnATTACK2_ST()
--------------------------------------------------
	Logg('OnAttackST')
	if MyEnemy == 0 then return end
	local Ex, Ey = GetV(V_POSITION, MyEnemy)
	if (Ex == -1) or (MOTION_DEAD == GetV(V_MOTION, MyEnemy)) then
		if (MyEnemyTypeID>0) then 
			Settings.TotalExp=Settings.TotalExp+MOBDATA[MyEnemyTypeID][MOB_P_EXP]
			Settings.TotalKills=Settings.TotalKills+1
			Tick()
			MyEnemyTypeID=0
		end
	end
	StdOnATTACK_ST()
end

---------------------------------------------
function GetFullTact2(ID)
-- Homun uvidel priseru. Zapisem si jej id a pridam aj do DNA
---------------------------------------------
	Logg('GetFullTact : '..ID)
	if (Settings.Creatures[ID]==nil) then --nova prisera
		Logg('Nova prisera - '..ID)
		
		if (Tact[ID]~=nil) then 
			Settings.DNA[ID]={ID,Tact[ID][2],Tact[ID][3],Tact[ID][4]}
		else
			Settings.DNA[ID]={ID,DEFAULT_BEHA,DEFAULT_WITH,0}
		end
		Settings.Creatures[ID]=1
	end
	T=StdGetFullTact(ID)
	MyEnemyTypeID=ID
	EnemyName=T.CName
	return T
end

--------------------------------------------------
function AI2(myid)
--------------------------------------------------
	Tick()
	StdAI(myid)
end


--------------------------------------------------
function ModInit()
-- plugin initialization
--------------------------------------------------
	Settings=nil
	WriteTime=0

	-- Replace standard Mir AI's functions
	--GetFullTact kvoli vyberu nepriatela
	StdGetFullTact = GetFullTact
	GetFullTact = GetFullTact2
	--OnATTACK_ST kvoli zabitemu nepriatelovi
	StdOnATTACK_ST=OnATTACK_ST
	OnATTACK_ST=OnATTACK2_ST

	StdAI=AI
	AI=AI2

	GAOnInit() --spustim hlavnu proceduru
end
